=== modified file 'drizzled/handler.cc'
--- drizzled/handler.cc	2009-06-05 18:49:23 +0000
+++ drizzled/handler.cc	2009-06-08 13:39:05 +0000
@@ -822,8 +822,7 @@
       protocol->store((int64_t)xs->xid.formatID);
       protocol->store((int64_t)xs->xid.gtrid_length);
       protocol->store((int64_t)xs->xid.bqual_length);
-      protocol->store(xs->xid.data, xs->xid.gtrid_length+xs->xid.bqual_length,
-                      &my_charset_bin);
+      protocol->store(xs->xid.data, xs->xid.gtrid_length+xs->xid.bqual_length);
       if (protocol->write())
       {
         pthread_mutex_unlock(&LOCK_xid_cache);
@@ -3253,9 +3252,9 @@
 {
   Protocol *protocol= session->protocol;
   protocol->prepareForResend();
-  protocol->store(type, type_len, system_charset_info);
-  protocol->store(file, file_len, system_charset_info);
-  protocol->store(status, status_len, system_charset_info);
+  protocol->store(type, type_len);
+  protocol->store(file, file_len);
+  protocol->store(status, status_len);
   if (protocol->write())
     return true;
   return false;

=== modified file 'drizzled/item.cc'
--- drizzled/item.cc	2009-05-27 21:11:30 +0000
+++ drizzled/item.cc	2009-06-08 13:39:05 +0000
@@ -1576,7 +1576,7 @@
   {
     String *res;
     if ((res=val_str(buffer)))
-      result= protocol->store(res->ptr(),res->length(),res->charset());
+      result= protocol->store(res->ptr(),res->length());
     break;
   }
   case DRIZZLE_TYPE_LONG:

=== modified file 'drizzled/plugin/protocol.h'
--- drizzled/plugin/protocol.h	2009-04-25 00:27:31 +0000
+++ drizzled/plugin/protocol.h	2009-06-08 13:39:05 +0000
@@ -81,14 +81,13 @@
   virtual bool store(uint64_t from)= 0;
   virtual bool store(double from, uint32_t decimals, String *buffer)= 0;
   virtual bool store(const DRIZZLE_TIME *from)= 0;
-  virtual bool store(const char *from, const CHARSET_INFO * const cs)
+  virtual bool store(const char *from)
   {
     if (from == NULL) 
       return store();
-    return store(from, strlen(from), cs);
+    return store(from, strlen(from));
   }
-  virtual bool store(const char *from, size_t length,
-                     const CHARSET_INFO * const cs)= 0;
+  virtual bool store(const char *from, size_t length)= 0;
 };
 
 class ProtocolFactory

=== modified file 'drizzled/show.cc'
--- drizzled/show.cc	2009-06-05 02:29:41 +0000
+++ drizzled/show.cc	2009-06-08 13:39:05 +0000
@@ -382,13 +382,12 @@
   protocol->prepareForResend();
   {
     if (table_list->schema_table)
-      protocol->store(table_list->schema_table->table_name,
-                      system_charset_info);
+      protocol->store(table_list->schema_table->table_name);
     else
-      protocol->store(table_list->table->alias, system_charset_info);
+      protocol->store(table_list->table->alias);
   }
 
-  protocol->store(buffer.ptr(), buffer.length(), buffer.charset());
+  protocol->store(buffer.ptr(), buffer.length());
 
   if (protocol->write())
     return true;
@@ -423,8 +422,8 @@
     return true;
 
   protocol->prepareForResend();
-  protocol->store(dbname, strlen(dbname), system_charset_info);
-  protocol->store(buffer.ptr(), buffer.length(), buffer.charset());
+  protocol->store(dbname, strlen(dbname));
+  protocol->store(buffer.ptr(), buffer.length());
 
   if (protocol->write())
     return true;
@@ -1068,18 +1067,18 @@
   {
     protocol->prepareForResend();
     protocol->store((uint64_t) session_info->thread_id);
-    protocol->store(session_info->user, system_charset_info);
-    protocol->store(session_info->host, system_charset_info);
-    protocol->store(session_info->db, system_charset_info);
-    protocol->store(session_info->proc_info, system_charset_info);
+    protocol->store(session_info->user);
+    protocol->store(session_info->host);
+    protocol->store(session_info->db);
+    protocol->store(session_info->proc_info);
 
     if (session_info->start_time)
       protocol->store((uint32_t) (now - session_info->start_time));
     else
       protocol->store();
 
-    protocol->store(session_info->state_info, system_charset_info);
-    protocol->store(session_info->query, system_charset_info);
+    protocol->store(session_info->state_info);
+    protocol->store(session_info->query);
 
     if (protocol->write())
       break; /* purecov: inspected */

=== modified file 'drizzled/sql_error.cc'
--- drizzled/sql_error.cc	2009-05-15 07:16:35 +0000
+++ drizzled/sql_error.cc	2009-06-08 13:39:05 +0000
@@ -227,9 +227,9 @@
       break;
     protocol->prepareForResend();
     protocol->store(warning_level_names[err->level].str,
-		    warning_level_names[err->level].length, system_charset_info);
+		    warning_level_names[err->level].length);
     protocol->store((uint32_t) err->code);
-    protocol->store(err->msg, strlen(err->msg), system_charset_info);
+    protocol->store(err->msg, strlen(err->msg));
     if (protocol->write())
       return(true);
   }

=== modified file 'drizzled/sql_table.cc'
--- drizzled/sql_table.cc	2009-06-05 18:49:23 +0000
+++ drizzled/sql_table.cc	2009-06-08 13:39:05 +0000
@@ -2103,10 +2103,10 @@
 {
   Protocol *protocol= session->protocol;
   protocol->prepareForResend();
-  protocol->store(table->alias, system_charset_info);
-  protocol->store((char*) operator_name, system_charset_info);
-  protocol->store(STRING_WITH_LEN("error"), system_charset_info);
-  protocol->store(errmsg, system_charset_info);
+  protocol->store(table->alias);
+  protocol->store((char*) operator_name);
+  protocol->store(STRING_WITH_LEN("error"));
+  protocol->store(errmsg);
   session->clear_error();
   if (protocol->write())
     return -1;
@@ -2376,12 +2376,12 @@
       char buff[FN_REFLEN + DRIZZLE_ERRMSG_SIZE];
       uint32_t length;
       protocol->prepareForResend();
-      protocol->store(table_name, system_charset_info);
-      protocol->store(operator_name, system_charset_info);
-      protocol->store(STRING_WITH_LEN("error"), system_charset_info);
+      protocol->store(table_name);
+      protocol->store(operator_name);
+      protocol->store(STRING_WITH_LEN("error"));
       length= snprintf(buff, sizeof(buff), ER(ER_OPEN_AS_READONLY),
                        table_name);
-      protocol->store(buff, length, system_charset_info);
+      protocol->store(buff, length);
       ha_autocommit_or_rollback(session, 0);
       session->endTransaction(COMMIT);
       session->close_thread_tables();
@@ -2414,11 +2414,10 @@
     {
       /* purecov: begin inspected */
       protocol->prepareForResend();
-      protocol->store(table_name, system_charset_info);
-      protocol->store(operator_name, system_charset_info);
-      protocol->store(STRING_WITH_LEN("warning"), system_charset_info);
-      protocol->store(STRING_WITH_LEN("Table is marked as crashed"),
-                      system_charset_info);
+      protocol->store(table_name);
+      protocol->store(operator_name);
+      protocol->store(STRING_WITH_LEN("warning"));
+      protocol->store(STRING_WITH_LEN("Table is marked as crashed"));
       if (protocol->write())
         goto err;
       /* purecov: end */
@@ -2455,20 +2454,19 @@
       while ((err= it++))
       {
         protocol->prepareForResend();
-        protocol->store(table_name, system_charset_info);
-        protocol->store((char*) operator_name, system_charset_info);
+        protocol->store(table_name);
+        protocol->store(operator_name);
         protocol->store(warning_level_names[err->level].str,
-                        warning_level_names[err->level].length,
-                        system_charset_info);
-        protocol->store(err->msg, system_charset_info);
+                        warning_level_names[err->level].length);
+        protocol->store(err->msg);
         if (protocol->write())
           goto err;
       }
       drizzle_reset_errors(session, true);
     }
     protocol->prepareForResend();
-    protocol->store(table_name, system_charset_info);
-    protocol->store(operator_name, system_charset_info);
+    protocol->store(table_name);
+    protocol->store(operator_name);
 
 send_result_message:
 
@@ -2478,45 +2476,41 @@
 	char buf[ERRMSGSIZE+20];
 	uint32_t length=snprintf(buf, ERRMSGSIZE,
                              ER(ER_CHECK_NOT_IMPLEMENTED), operator_name);
-	protocol->store(STRING_WITH_LEN("note"), system_charset_info);
-	protocol->store(buf, length, system_charset_info);
+	protocol->store(STRING_WITH_LEN("note"));
+	protocol->store(buf, length);
       }
       break;
 
     case HA_ADMIN_OK:
-      protocol->store(STRING_WITH_LEN("status"), system_charset_info);
-      protocol->store(STRING_WITH_LEN("OK"), system_charset_info);
+      protocol->store(STRING_WITH_LEN("status"));
+      protocol->store(STRING_WITH_LEN("OK"));
       break;
 
     case HA_ADMIN_FAILED:
-      protocol->store(STRING_WITH_LEN("status"), system_charset_info);
-      protocol->store(STRING_WITH_LEN("Operation failed"),
-                      system_charset_info);
+      protocol->store(STRING_WITH_LEN("status"));
+      protocol->store(STRING_WITH_LEN("Operation failed"));
       break;
 
     case HA_ADMIN_REJECT:
-      protocol->store(STRING_WITH_LEN("status"), system_charset_info);
-      protocol->store(STRING_WITH_LEN("Operation need committed state"),
-                      system_charset_info);
+      protocol->store(STRING_WITH_LEN("status"));
+      protocol->store(STRING_WITH_LEN("Operation need committed state"));
       open_for_modify= false;
       break;
 
     case HA_ADMIN_ALREADY_DONE:
-      protocol->store(STRING_WITH_LEN("status"), system_charset_info);
-      protocol->store(STRING_WITH_LEN("Table is already up to date"),
-                      system_charset_info);
+      protocol->store(STRING_WITH_LEN("status"));
+      protocol->store(STRING_WITH_LEN("Table is already up to date"));
       break;
 
     case HA_ADMIN_CORRUPT:
-      protocol->store(STRING_WITH_LEN("error"), system_charset_info);
-      protocol->store(STRING_WITH_LEN("Corrupt"), system_charset_info);
+      protocol->store(STRING_WITH_LEN("error"));
+      protocol->store(STRING_WITH_LEN("Corrupt"));
       fatal_error=1;
       break;
 
     case HA_ADMIN_INVALID:
-      protocol->store(STRING_WITH_LEN("error"), system_charset_info);
-      protocol->store(STRING_WITH_LEN("Invalid argument"),
-                      system_charset_info);
+      protocol->store(STRING_WITH_LEN("error"));
+      protocol->store(STRING_WITH_LEN("Invalid argument"));
       break;
 
     case HA_ADMIN_TRY_ALTER:
@@ -2561,13 +2555,13 @@
           else
           {
             /* Hijack the row already in-progress. */
-            protocol->store(STRING_WITH_LEN("error"), system_charset_info);
-            protocol->store(err_msg, system_charset_info);
+            protocol->store(STRING_WITH_LEN("error"));
+            protocol->store(err_msg);
             (void)protocol->write();
             /* Start off another row for HA_ADMIN_FAILED */
             protocol->prepareForResend();
-            protocol->store(table_name, system_charset_info);
-            protocol->store(operator_name, system_charset_info);
+            protocol->store(table_name);
+            protocol->store(operator_name);
           }
           session->clear_error();
         }
@@ -2583,9 +2577,9 @@
       char buf[ERRMSGSIZE];
       uint32_t length;
 
-      protocol->store(STRING_WITH_LEN("error"), system_charset_info);
+      protocol->store(STRING_WITH_LEN("error"));
       length=snprintf(buf, ERRMSGSIZE, ER(ER_TABLE_NEEDS_UPGRADE), table->table_name);
-      protocol->store(buf, length, system_charset_info);
+      protocol->store(buf, length);
       fatal_error=1;
       break;
     }
@@ -2596,8 +2590,8 @@
         uint32_t length=snprintf(buf, ERRMSGSIZE,
                              _("Unknown - internal error %d during operation"),
                              result_code);
-        protocol->store(STRING_WITH_LEN("error"), system_charset_info);
-        protocol->store(buf, length, system_charset_info);
+        protocol->store(STRING_WITH_LEN("error"));
+        protocol->store(buf, length);
         fatal_error=1;
         break;
       }
@@ -4525,7 +4519,7 @@
     session->clear_error();			// these errors shouldn't get client
 
     protocol->prepareForResend();
-    protocol->store(table_name, system_charset_info);
+    protocol->store(table_name);
 
     if (!t)
     {

=== modified file 'plugin/myisam/ha_myisam.cc'
--- plugin/myisam/ha_myisam.cc	2009-06-05 18:49:23 +0000
+++ plugin/myisam/ha_myisam.cc	2009-06-08 13:39:05 +0000
@@ -127,10 +127,10 @@
     push_warning).
   */
   protocol->prepareForResend();
-  protocol->store(name, length, system_charset_info);
-  protocol->store(param->op_name, system_charset_info);
-  protocol->store(msg_type, system_charset_info);
-  protocol->store(msgbuf, msg_length, system_charset_info);
+  protocol->store(name, length);
+  protocol->store(param->op_name);
+  protocol->store(msg_type);
+  protocol->store(msgbuf, msg_length);
   if (protocol->write())
     errmsg_printf(ERRMSG_LVL_ERROR, "Failed on drizzleclient_net_write, writing to stderr instead: %s\n",
 		    msgbuf);

=== modified file 'plugin/oldlibdrizzle/oldlibdrizzle.cc'
--- plugin/oldlibdrizzle/oldlibdrizzle.cc	2009-04-10 23:38:17 +0000
+++ plugin/oldlibdrizzle/oldlibdrizzle.cc	2009-06-08 13:39:05 +0000
@@ -115,61 +115,6 @@
 }
 
 
-/*
-  netStoreData() - extended version with character set conversion.
-
-  It is optimized for short strings whose length after
-  conversion is garanteed to be less than 251, which accupies
-  exactly one byte to store length. It allows not to use
-  the "convert" member as a temporary buffer, conversion
-  is done directly to the "packet" member.
-  The limit 251 is good enough to optimize send_fields()
-  because column, table, database names fit into this limit.
-*/
-
-bool ProtocolOldLibdrizzle::netStoreData(const unsigned char *from, size_t length,
-                              const CHARSET_INFO * const from_cs,
-                              const CHARSET_INFO * const to_cs)
-{
-  uint32_t dummy_errors;
-  /* Calculate maxumum possible result length */
-  uint32_t conv_length= to_cs->mbmaxlen * length / from_cs->mbminlen;
-  if (conv_length > 250)
-  {
-    /*
-      For strings with conv_length greater than 250 bytes
-      we don't know how many bytes we will need to store length: one or two,
-      because we don't know result length until conversion is done.
-      For example, when converting from utf8 (mbmaxlen=3) to latin1,
-      conv_length=300 means that the result length can vary between 100 to 300.
-      length=100 needs one byte, length=300 needs to bytes.
-
-      Thus conversion directly to "packet" is not worthy.
-      Let's use "convert" as a temporary buffer.
-    */
-    return (convert->copy((const char*) from, length, from_cs,
-                          to_cs, &dummy_errors) ||
-            netStoreData((const unsigned char*) convert->ptr(), convert->length()));
-  }
-
-  size_t packet_length= packet->length();
-  size_t new_length= packet_length + conv_length + 1;
-
-  if (new_length > packet->alloced_length() && packet->realloc(new_length))
-    return 1;
-
-  char *length_pos= (char*) packet->ptr() + packet_length;
-  char *to= length_pos + 1;
-
-  to+= copy_and_convert(to, conv_length, to_cs,
-                        (const char*) from, length, from_cs, &dummy_errors);
-
-  drizzleclient_net_store_length((unsigned char*) length_pos, to - length_pos - 1);
-  packet->length((uint32_t) (to - packet->ptr()));
-  return 0;
-}
-
-
 /**
   Return ok to the client.
 
@@ -398,48 +343,26 @@
   while ((item=it++))
   {
     char *pos;
-    const CHARSET_INFO * const cs= system_charset_info;
     Send_field field;
     item->make_field(&field);
 
     prepareForResend();
 
-    if (store(STRING_WITH_LEN("def"), cs) ||
-        store(field.db_name, cs) ||
-        store(field.table_name, cs) ||
-        store(field.org_table_name, cs) ||
-        store(field.col_name, cs) ||
-        store(field.org_col_name, cs) ||
+    if (store(STRING_WITH_LEN("def")) ||
+        store(field.db_name) ||
+        store(field.table_name) ||
+        store(field.org_table_name) ||
+        store(field.col_name) ||
+        store(field.org_col_name) ||
         packet->realloc(packet->length()+12))
       goto err;
 
     /* Store fixed length fields */
     pos= (char*) packet->ptr()+packet->length();
     *pos++= 12;                // Length of packed fields
-    if (item->collation.collation == &my_charset_bin)
-    {
-      /* No conversion */
-      int2store(pos, field.charsetnr);
-      int4store(pos+2, field.length);
-    }
-    else
-    {
-      /* With conversion */
-      uint32_t max_char_len;
-      int2store(pos, cs->number);
-      /*
-        For TEXT/BLOB columns, field_length describes the maximum data
-        length in bytes. There is no limit to the number of characters
-        that a TEXT column can store, as long as the data fits into
-        the designated space.
-        For the rest of textual columns, field_length is evaluated as
-        char_count * mbmaxlen, where character count is taken from the
-        definition of the column. In other words, the maximum number
-        of characters here is limited by the column definition.
-      */
-      max_char_len= field.length / item->collation.collation->mbmaxlen;
-      int4store(pos+2, max_char_len * cs->mbmaxlen);
-    }
+    /* No conversion */
+    int2store(pos, field.charsetnr);
+    int4store(pos+2, field.length);
     pos[6]= field.type;
     int2store(pos+7,field.flags);
     pos[9]= (char) field.decimals;
@@ -627,33 +550,9 @@
 }
 
 
-/**
-  Auxilary function to convert string to the given character set
-  and store in network buffer.
-*/
-
-bool ProtocolOldLibdrizzle::storeString(const char *from, size_t length,
-                                        const CHARSET_INFO * const fromcs,
-                                        const CHARSET_INFO * const tocs)
-{
-  /* 'tocs' is set 0 when client issues SET character_set_results=NULL */
-  if (tocs && !my_charset_same(fromcs, tocs) &&
-      fromcs != &my_charset_bin &&
-      tocs != &my_charset_bin)
-  {
-    /* Store with conversion */
-    return netStoreData((unsigned char*) from, length, fromcs, tocs);
-  }
-  /* Store without conversion */
-  return netStoreData((unsigned char*) from, length);
-}
-
-
-bool ProtocolOldLibdrizzle::store(const char *from, size_t length,
-                          const CHARSET_INFO * const fromcs)
-{
-  const CHARSET_INFO * const tocs= default_charset_info;
-  return storeString(from, length, fromcs, tocs);
+bool ProtocolOldLibdrizzle::store(const char *from, size_t length)
+{
+  return netStoreData((const unsigned char *)from, length);
 }
 
 
@@ -699,11 +598,10 @@
     return store();
   char buff[MAX_FIELD_WIDTH];
   String str(buff,sizeof(buff), &my_charset_bin);
-  const CHARSET_INFO * const tocs= default_charset_info;
 
   from->val_str(&str);
 
-  return storeString(str.ptr(), str.length(), str.charset(), tocs);
+  return netStoreData((const unsigned char *)str.ptr(), str.length());
 }
 
 

=== modified file 'plugin/oldlibdrizzle/oldlibdrizzle.h'
--- plugin/oldlibdrizzle/oldlibdrizzle.h	2009-04-10 18:23:14 +0000
+++ plugin/oldlibdrizzle/oldlibdrizzle.h	2009-06-08 13:39:05 +0000
@@ -37,12 +37,6 @@
   uint32_t field_pos;
   uint32_t field_count;
   bool netStoreData(const unsigned char *from, size_t length);
-  bool netStoreData(const unsigned char *from, size_t length,
-                    const CHARSET_INFO * const fromcs,
-                    const CHARSET_INFO * const tocs);
-  bool storeString(const char *from, size_t length,
-                   const CHARSET_INFO * const fromcs,
-                   const CHARSET_INFO * const tocs);
 
   /**
    * Performs handshake with client and authorizes user.
@@ -91,8 +85,7 @@
   virtual bool store(uint64_t from);
   virtual bool store(double from, uint32_t decimals, String *buffer);
   virtual bool store(const DRIZZLE_TIME *from);
-  virtual bool store(const char *from, size_t length,
-                     const CHARSET_INFO * const cs);
+  virtual bool store(const char *from, size_t length);
 };
 
 class ProtocolFactoryOldLibdrizzle: public ProtocolFactory

=== modified file 'tests/r/type_enum.result'
--- tests/r/type_enum.result	2009-04-28 01:03:16 +0000
+++ tests/r/type_enum.result	2009-06-08 13:39:05 +0000
@@ -1670,8 +1670,8 @@
 alter table t1 add c enum ('Y','N') COLLATE utf8_bin;
 select * from t1;
 Catalog	Database	Table	Table_alias	Column	Column_alias	Type	Length	Max length	Is_null	Flags	Decimals	Charsetnr
-def	test	t1	t1	a	a	10	4	1	Y	384	0	45
-def	test	t1	t1	c	c	10	4	0	Y	384	0	45
+def	test	t1	t1	a	a	10	4	1	Y	384	0	46
+def	test	t1	t1	c	c	10	4	0	Y	384	0	46
 a	c
 Y	NULL
 drop table t1;

